﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using wms.service;
using wms.service.IService;

namespace wms.api.Controllers
{
    /// <summary>
    ///  数据库初始化控制器
    /// </summary>
    [Route("api/[controller]/[action]")]
    [ApiController]
    public class DBInitController : ControllerBase
    {
        private readonly IDBService _dBService;
        public DBInitController(IDBService dBService)
        {
            _dBService = dBService;
        }
        /// <summary>
        /// 初始化盘条库
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "InitPtDB")]
        public string InitPtDB()
        {
            _dBService.InitPtDB();
            return "";
        }
        /// <summary>
        /// 初始化合金库
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "InitHjDB")]
        public string InitHjDB()
        {
             _dBService.InitHjDB();
            return "";
        }
        /// <summary>
        /// 初始化分拣库
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "InitFjDB")]
        public string InitFjDB()
        {
             _dBService.InitFjDB();
            return "";
        }
        /// <summary>
        /// 初始化时效库
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "InitSxDB")]
        public string InitSxDB()
        {
             _dBService.InitSxDB();
            return "";
        }
        /// <summary>
        /// 初始化成品库
        /// </summary>
        /// <returns></returns>
        [HttpGet(Name = "InitCpDB")]
        public string InitCpDB()
        {
             _dBService.InitCpDB();
            return "";
        }
    }
}
