﻿using System.ComponentModel;

namespace wms.dto
{
    /// <summary>
    ///  分拣业务类型
    /// </summary>
    public enum FJTaskBusType
    {
        /// <summary>
        ///  默认
        /// </summary>
        [Description("默认")]
        def = 0,

        /// <summary>
        ///  一楼空托入库
        /// </summary>
        [Description("一楼空托入库")]
        OneLayerManualPallets = 1,

        /// <summary>
        ///  一楼自动入空托盘
        /// </summary>
        [Description("一楼自动入空托盘")]
        OneLayerAutoPallets = 2,

        /// <summary>
        ///  手动出库
        /// </summary>
        [Description("手动出库")]
        TaskBusType_FJ_ManualOut = 3,

        /// <summary>
        ///  二楼组盘
        /// </summary>
        [Description("二楼组盘")]
        二楼组盘 = 4,

        /// <summary>
        ///  二楼空托盘组出库
        /// </summary>
        [Description("二楼空托盘组出库")]
        二楼空托盘组出库 = 5,

        /// <summary>
        ///  组盘_托盘
        /// </summary>
        [Description("组盘_托盘")]
        组盘_托盘 = 6,

        /// <summary>
        ///  码垛入库
        /// </summary>
        [Description("码垛入库")]
        码垛入库 = 7,

        /// <summary>
        ///  环形库出库码垛任务
        /// </summary>
        [Description("环形库出库码垛任务")]
        环形库出库码垛任务 = 8,

        /// <summary>
        ///  车间叫料
        /// </summary>
        [Description("车间叫料")]
        车间叫料 = 9,

        /// <summary>
        ///  二楼异常组盘
        /// </summary>
        [Description("二楼异常组盘")]
        二楼异常组盘 = 10,

        /// <summary>
        ///  车间手动叫料
        /// </summary>
        [Description("车间手动叫料")]
        车间手动叫料 = 11,

        /// <summary>
        ///  二楼二次码垛出库
        /// </summary>
        [Description("二楼二次码垛出库")]
        二楼二次码垛出库 = 12,

        /// <summary>
        ///  人工满托入库
        /// </summary>
        [Description("人工满托入库")]
        人工满托入库 = 13,

        /// <summary>
        ///  芯股用空托盘入库
        /// </summary>
        [Description("芯股用空托盘入库")]
        芯股用空托盘入库 = 14,

        /// <summary>
        ///  芯股站台送空托
        /// </summary>
        [Description("芯股站台送空托")]
        芯股站台送空托 = 15,

        /// <summary>
        ///  皮盘入库
        /// </summary>
        [Description("皮盘入库")]
        皮盘入库 = 16,

        /// <summary>
        ///  重绕满托入库
        /// </summary>
        [Description("重绕满托入库")]
        重绕满托入库 = 17,

        /// <summary>
        ///  帘线退料重绕
        /// </summary>
        [Description("帘线退料重绕")]
        帘线退料重绕 = 18,

        /// <summary>
        ///  UT人工满托入库
        /// </summary>
        [Description("UT人工满托入库")]
        UT人工满托入库 = 19,
    }

    /// <summary>
    ///  托盘类型
    /// </summary>
    public enum FJPalletType
    {
        /// <summary>
        ///  09使用的托盘
        /// </summary>
        [Description("09使用的托盘")]
        Pallet09 = 1,

        /// <summary>
        ///  非09使用的托盘
        /// </summary>
        [Description("非09使用的托盘")]
        PalletNo09 = 2,
    }

    /// <summary>
    /// 货位状态
    /// </summary>
    public enum FJLocationState
    {
        /// <summary>
        ///  货位空
        /// </summary>
        [Description("货位空")]
        LocationState_Empty = 1,

        /// <summary>
        ///  货位有货
        /// </summary>
        [Description("货位有货")]
        LocationState_Full = 2,

        /// <summary>
        ///  入库锁
        /// </summary>
        [Description("入库锁")]
        LocationState_StockIn = 3,

        /// <summary>
        ///  出库锁
        /// </summary>
        [Description("出库锁")]
        LocationState_StockOut = 4,

        /// <summary>
        ///  移库锁
        /// </summary>
        [Description("移库锁")]
        LocationState_StockMove = 5,
    }

    /// <summary>
    /// 容器类型
    /// </summary>
    public enum FJContainerType
    {
        /// <summary>
        ///  工字轮
        /// </summary>
        [Description("工字轮")]
        ContainerType_IShapedWheel = 1,

        /// <summary>
        ///  托盘
        /// </summary>
        [Description("托盘")]
        ContainerType_Pallet = 2,
    }

    /// <summary>
    /// 库存状态
    /// </summary>
    public enum FJInvState
    {
        /// <summary>
        /// 已组盘
        /// </summary>
        [Description("已组盘")]
        InvEcecState_BuildUp = 1,

        /// <summary>
        /// 已入库
        /// </summary>
        [Description("已入库")]
        InvEcecState_In = 2,

        /// <summary>
        /// 出库中
        /// </summary>
        [Description("出库中")]
        InvEcecState_OutGoing = 3,

        /// <summary>
        /// 已出库
        /// </summary>
        [Description("已出库")]
        InvEcecState_Out = 4,
    }

    /// <summary>
    ///  组盘类型
    /// </summary>
    public enum FJContGrpType
    {
        /// <summary>
        ///  物料盘
        /// </summary>
        [Description("物料盘")]
        Material = 1,

        /// <summary>
        ///  空盘组
        /// </summary>
        [Description("空盘组")]
        EmptyCon = 2,

        /// <summary>
        ///  空盘
        /// </summary>
        [Description("空盘")]
        EmptyPal = 3,
    }

    /// <summary>
    /// 库存锁定状态
    /// </summary>
    public enum FJInvLockState
    {
        /// <summary>
        /// 正常
        /// </summary>
        [Description("正常")]
        InvState_Normal,

        /// <summary>
        /// 锁定
        /// </summary>
        [Description("锁定")]
        InvState_Lock,
    }

    /// <summary>
    /// 单据类型
    /// </summary>
    public enum FJDocType
    {
        /// <summary>
        ///  空托盘入库
        /// </summary>
        [Description("空托盘入库")]
        DocType_FJ_EmptyPalletsStockIn = 1,

        /// <summary>
        ///  满轮码垛
        /// </summary>
        [Description("满轮码垛")]
        FullWheelPalletizing = 2,
    }

    /// <summary>
    ///  出入库类型
    /// </summary>
    public enum FJInvInOutType
    {
        /// <summary>
        ///  默认
        /// </summary>
        [Description("默认")]
        Default = 0,

        /// <summary>
        /// 入库
        /// </summary>
        [Description("入库")]
        In = 1,

        /// <summary>
        /// 出库
        /// </summary>
        [Description("出库")]
        Out = 2,
    }

    /// <summary>
    ///  工字轮类型
    /// </summary>
    public enum FjHwTypeCode
    {
        /// <summary>
        ///  工字轮09
        /// </summary>
        ShapedWheel09 = 1,

        /// <summary>
        ///  工字轮50
        /// </summary>
        ShapedWheel50 = 2,

        /// <summary>
        ///  工字轮34
        /// </summary>
        ShapedWheel34 = 3,

        /// <summary>
        ///  工字轮18
        /// </summary>
        ShapedWheel18 = 4,
    }

    /// <summary>
    ///  货位类型
    /// </summary>
    public enum FjLocationType
    {
        /// <summary>
        /// 立库货位
        /// </summary>
        Storage = 1,

        /// <summary>
        /// 平库货位
        /// </summary>
        Pingku = 2,

        /// <summary>
        /// 虚拟货位
        /// </summary>
        Virtual = 3,

        /// <summary>
        ///  环形库货位
        /// </summary>
        RingLibrary = 4,
    }

    /// <summary>
    /// 货位状态
    /// </summary>
    public enum FjLocationState
    {
        /// <summary>
        /// 货位空
        /// </summary>
        [Description("货位空")]
        Empty = 1,

        /// <summary>
        /// 货位有货
        /// </summary>
        [Description("货位有货")]
        Full = 2,

        /// <summary>
        /// 入库锁
        /// </summary>
        [Description("入库锁")]
        StockIn = 3,

        /// <summary>
        /// 出库锁
        /// </summary>
        [Description("出库锁")]
        StockOut = 4,

        /// <summary>
        /// 移库锁
        /// </summary>
        [Description("移库锁")]
        StockMove = 5,
    }
}