﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace wms.dto.request.fj
{
    /// <summary>
    ///  创建空托盘库存 请求体
    /// </summary>
    public class FJBuildEmptyPalletsStockRequest : BaseRequest
    {
        /// <summary>
        ///  托盘编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string PalletCode { get; set; }

        /// <summary>
        ///  托盘类型
        /// </summary>
        public FJPalletType PalletType { get; set; }

        /// <summary>
        ///  入库起始地址
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string StartLoc { get; set; }

        /// <summary>
        ///  仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WareCode { get; set; }

        /// <summary>
        ///  托盘数量
        /// </summary>
        [Description("托盘数量")]
        public string PalletNum { get; set; }

        /// <summary>
        ///  大小货 1表示小货 2表示大货
        /// </summary>
        public int Height { get; set; }
    }

    /// <summary>
    ///  FJ构建空托库存
    /// </summary>
    public class FJBuildEmptyPalletsStockDto : BaseRequest
    {
        /// <summary>
        ///  托盘编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string PalletCode { get; set; }

        /// <summary>
        ///  托盘类型
        /// </summary>
        public FJPalletType PalletType { get; set; }

        /// <summary>
        ///  托盘数量
        /// </summary>
        [Description("托盘数量")]
        public string PalletNum { get; set; }

        /// <summary>
        ///  入库起始地址
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string StartLoc { get; set; }

        /// <summary>
        ///  仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WareCode { get; set; }

        /// <summary>
        /// 楼层
        /// </summary>
        public int Floor { get; set; }

        /// <summary>
        ///  业务类型
        /// </summary>
        public FJTaskBusType BusType { get; set; }

        /// <summary>
        /// 更新时间
        /// </summary>
        public string? UpdatedTime { get; set; }
    }
}
