﻿using System.Collections.Generic;

namespace wms.dto.request.fj
{
    /// <summary>
    ///  创建有料满托入库任务
    /// </summary>
    public class CreateMaterialPalletWarehouTaskRequest : BaseRequest
    {
        /// <summary>
        /// 托盘号
        /// </summary>
        public string TrayCode { get; set; }

        /// <summary>
        /// 工字轮号
        /// </summary>
        public string SpoolNr { get; set; }

        /// <summary>
        /// 投入物料号
        /// </summary>
        public string InMaterialCode { get; set; }

        /// <summary>
        /// 产出物料号
        /// </summary>
        public string OutMaterialCode { get; set; }

        /// <summary>
        ///  站台号
        /// </summary>
        public string LocCode { get; set; }
    }

    /// <summary>
    ///  创建芯股满托库存信息
    /// </summary>
    public class CreateMaterialPalletWarehouTask1Request : BaseRequest
    {
        /// <summary>
        /// 托盘号
        /// </summary>
        public string TrayCode { get; set; }

        /// <summary>
        /// 工字轮号
        /// </summary>
        public string SpoolNr { get; set; }

        /// <summary>
        /// 投入物料号
        /// </summary>
        public string InMaterialCode { get; set; }

        /// <summary>
        /// 产出物料号
        /// </summary>
        public string OutMaterialCode { get; set; }

        /// <summary>
        ///  站台号
        /// </summary>
        public string LocCode { get; set; }
    }

    /// <summary>
    ///  重绕创建满托任务
    /// </summary>
    public class RewindFullPalletTaskRequest : BaseRequest
    {
        /// <summary>
        /// 托盘号
        /// </summary>
        public string TrayCode { get; set; }

        /// <summary>
        /// 工字轮组
        /// </summary>
        public List<SpoolMaterialInfoTransRequest> SpoolGroup { get; set; }
    }

    /// <summary>
    ///  退料任务创建
    /// </summary>
    public class MaterialReturnTaskCreatorRequest : BaseRequest
    {
        /// <summary>
        /// 托盘号
        /// </summary>
        public string TrayCode { get; set; }

        /// <summary>
        ///  机台号
        /// </summary>
        public string LocCode { get; set; }
    }
}