﻿using System.ComponentModel.DataAnnotations;

namespace wms.dto.request.fj
{
    /// <summary>
    ///  分拣申请货位
    /// </summary>
    public class FJApplyStockInLocRequest : BaseRequest
    {
        /// <summary>
        /// WMS任务号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int TaskNum { get; set; }

        /// <summary>
        /// 巷道号
        /// </summary>
        public int TunnelNum { get; set; }

        /// <summary>
        /// 取货地点设备编号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string PickUpEquipmentNo { get; set; }

        /// <summary>
        ///  大小货 1表示小货 2表示大货
        /// </summary>
        public int Height { get; set; }
    }
}
