﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.fj
{
    public class FjProductionBackRequest:BaseRequest
    {
        /// <summary>
        /// 退料单号
        /// </summary>
        public string BillCode { get; set; }
        /// <summary>
        /// 操作类型(1退料/2余料（退料不传工字轮信息，只传点位）)
        /// </summary>
        public string BusType { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WareCode { get; set; }
        /// <summary>
        /// 机台号
        /// </summary>
        public string WbCode { get; set; }
    }
    public class FjProductionBackRequestItem
    {
        /// <summary>
        /// 工字轮条码
        /// </summary>
        public string SpoolCode { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 类型
        /// </summary>
        public string BusType { get; set; }
        /// <summary>
        /// 工字轮型号
        /// </summary>
        public string SpoolType { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        public DateTime ProductDate { get; set; }
        /// <summary>
        /// 时效期
        /// </summary>
        public decimal HoldDuration { get; set; }
        /// <summary>
        /// 等级
        /// </summary>
        public string Grade { get; set; }
        /// <summary>
        /// 长度
        /// </summary>
        public decimal Length { get; set; }
        /// <summary>
        /// 重量
        /// </summary>
        public decimal Weight { get; set; }
        /// <summary>
        /// 高度
        /// </summary>
        public decimal Height { get; set; }
        /// <summary>
        /// 是否快投
        /// </summary>
        public bool IsFast { get; set; }
        /// <summary>
        /// 单/双丝
        /// </summary>
        public string SilkType { get; set; }
    }
}
