﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.fj
{
    /// <summary>
    ///  工字轮注册信息
    /// </summary>
    public class SpoolMaterialInfoTransRequest:BaseRequest
    {
        /// <summary>
        /// 工字轮条码
        /// </summary>
        public string SpoolCode { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string? MatCode { get; set; }
        /// <summary>
        /// 类型（0：湿拉半成品；1：芯股）
        /// </summary>
        public int BusType { get; set; }
        /// <summary>
        /// 工字轮型号
        /// </summary>
        public string? SpoolType { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        public string ProductDate { get; set; }
        /// <summary>
        /// 时效期
        /// </summary>
        public decimal HoldDuration { get; set; }
        /// <summary>
        /// 等级
        /// </summary>
        public string? Grade { get; set; }
        /// <summary>
        /// 长度
        /// </summary>
        public decimal Length { get; set; }
        /// <summary>
        /// 重量
        /// </summary>
        public decimal Weight { get; set; }
        /// <summary>
        /// 高度
        /// </summary>
        public decimal Height { get; set; }
        /// <summary>
        /// 是否快投
        /// </summary>
        public bool IsFast { get; set; }
        /// <summary>
        /// 是否退料
        /// </summary>
        public bool IsBack { get; set; }
        /// <summary>
        /// 单/双丝
        /// </summary>
        public string? SilkType { get; set; }
        /// <summary>
        /// 湿拉工序工单号
        /// </summary>
        public string BillCode { get; set; }
        /// <summary>
        /// 生产订单号
        /// </summary>
        public string? WorkOrder { get; set; }
        public string? WbCode { get; set; }
        /// <summary>
        /// 手/自下盘类型（0自动；1手动）
        /// </summary>
        public int ManualType { get; set; } = 0;
    }
    public class TransTemp
    {
        public string Line { get; set; }
        public string Start { get; set; }
        public string End { get; set; }
    }
}
