﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.fj
{
    /// <summary>
    /// 配方信息请求实体
    /// </summary>
    public class WetFormulaInfoRequest:BaseRequest
    {
        /// <summary>
        /// 投料信息编码
        /// </summary>
        public string FeedCode { get; set; }
        /// <summary>
        /// 投料信息名称
        /// </summary>
        public string FeedName { get; set; }
        /// <summary>
        /// 产品物料编码
        /// </summary>
        public string MaterialCode { get; set; }
        /// <summary>
        /// 产品物料名称
        /// </summary>
        public string MaterialName { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 物料信息列表
        /// </summary>
        public List<WetFormulaInfoItem> FeedList { get; set; }
    }

    public class WetFormulaInfoItem
    {
        /// <summary>
        /// 产出物料编码
        /// </summary>
        public string OutMaterialCode { get; set; }
        /// <summary>
        /// 投入物料编码
        /// </summary>
        public string InMaterialCode { get; set; }
        public decimal Count { get; set; }
    }
}
