﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.hj
{
    public class AddJobRequest
    {
        public long Id { get; set; }
        [Required(ErrorMessage = "{0} 必须填写")]
        [MaxLength(200, ErrorMessage = "{0} 长度不可超过{1}")]
        public string Code { get; set; }
        [Required(ErrorMessage = "{0} 必须填写")]
        [MaxLength(200, ErrorMessage = "{0} 长度不可超过{1}")]
        public string Name { get; set; }
        public string JobGroupName { get; set; }
        [Required(ErrorMessage = "{0} 必须填写")]
        [MaxLength(100, ErrorMessage = "{0} 长度不可超过{1}")]
        public string JobType { get; set; }
        public string JobDescription { get; set; }
        public string TriggerName { get; set; }
        public string TriggerGroupName { get; set; }
        public string TriggerDescription { get; set; }
        public string CronExpression { get; set; }
        /// <summary>
        /// 接口地址列
        /// </summary>
        public List<JobApiRelation> JobList { get; set; }
    }
    public class JobApiRelation
    {
        public long Id { get; set; }
        public long JobId { get; set; }
        /// <summary>
        /// 接口地址
        /// </summary>
        [Required(ErrorMessage = "接口地址必须填写")]
        public string ApiUrl { get; set; }
        /// <summary>
        /// 请求体
        /// </summary>
        [Required(ErrorMessage = "请求体必须填写")]
        public string RequestBody { get; set; }
    }
}
