﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace wms.dto.request.hj.dto
{
    /// <summary>
    /// 报表反馈
    /// </summary>
    public class ReportResponse
    {
        /// <summary>
        /// 物料出入报表
        /// </summary>
        public class MaterReportResponse
        {
            [Description("容器ID")]
            public string RFID { get; set; }
            [Description("容器条码")]
            public string ContGrpBarCode { get; set; }
            [Description("操作状态")]
            public string ExecState { get; set; }
            [Description("执行单据号")]
            public string ExecDocsNo { get; set; }
            [Description("执行单据行号")]
            public string ExecDocsRowNo { get; set; }
            [Description("客户编码")]
            public string CustNo { get; set; }
            [Description("客户名称")]
            public string CustName { get; set; }
            [Description("摆放行")]
            public int PutRow { get; set; }
            [Description("摆放列")]
            public int PutCol { get; set; }
            [Description("摆放层")]
            public int PutLayer { get; set; }
            [Description("摆放位置编号")]
            public string PutLocNo { get; set; }
            [Description("材料号")]
            public string InvBarCode { get; set; }
            [Description("库存状态")]
            public string InvState { get; set; }
            [Description("入库单据号")]
            public string InDocsNo { get; set; }
            [Description("入库单据行号")]
            public string InDocsRowNo { get; set; }
            [Description("供应商编码")]
            public string SuppCode { get; set; }
            [Description("供应商名称")]
            public string SuppName { get; set; }
            [Description("仓库ID")]
            public long WareHouseId { get; set; }
            [Description("仓库名称")]
            public string WareHouseName { get; set; }
            [Description("物料ID")]
            public long MatId { get; set; }
            [Description("总重量")]
            public decimal TotalWtQty { get; set; }
            [Description("净重")]
            public decimal NetWQty { get; set; }
            [Description("皮重")]
            public decimal TareWQty { get; set; }
            [Description("长度")]
            public decimal LengthQty { get; set; }
            [Description("生产批号")]
            public string BatchNo { get; set; }
            [Description("生产时间")]
            public DateTime ProductTime { get; set; }
            [Description("第一次入库时间")]
            public DateTime OneInTime { get; set; }
            [Description("RFID条码")]
            public string RFIDBarCode { get; set; }
            [Description("工字轮规格")]
            public string HWSpec { get; set; }
            [Description("改手盘标记")]
            public bool IsSurplus { get; set; }
            [Description("返工标记")]
            public bool IsRework { get; set; }
            [Description("快投标记")]
            public bool IsFast { get; set; }
            [Description("是否异常")]
            public bool IsFail { get; set; }
            [Description("异常原因")]
            public string FailReason { get; set; }
            [Description("等级")]
            public string Grade { get; set; }
            [Description("是否退料")]
            public bool IsBack { get; set; }
            [Description("退料原因")]
            public string BackReason { get; set; }
            [Description("生产机台号")]
            public string ProductWbNo { get; set; }
            [Description("生产产线号")]
            public string ProductLineNo { get; set; }
            [Description("备注")]
            public string Remark { get; set; }
            [Description("巷道")]
            public string Tunnel { get; set; }
            [Description("起始地址")]
            public string StartPoint { get; set; }
            [Description("目标地址")]
            public string EndPoint { get; set; }
            [Description("任务号")]
            public int TaskCode { get; set; }
            [Description("任务类型")]
            public int TaskType { get; set; }
            [Description("任务状态")]
            public string TaskState { get; set; }
        }
        /// <summary>
        /// 实时库存报表
        /// </summary>
        public class RealTimeInventoryReportResponse
        {
            //[Description("容器类型")]
            //public string RFID { get; set; }
            [Description("容器条码")]
            public string ContGrpBarCode { get; set; }
            [Description("客户编码")]
            public string CustNo { get; set; }
            [Description("客户名称")]
            public string CustName { get; set; }
            [Description("摆放行")]
            public int PutRow { get; set; }
            [Description("摆放列")]
            public int PutCol { get; set; }
            [Description("摆放层")]
            public int PutLayer { get; set; }
            [Description("摆放位置编号")]
            public string PutLocNo { get; set; }
            [Description("材料号")]
            public string InvBarCode { get; set; }
            [Description("库存状态")]
            public string InvState { get; set; }
            [Description("入库单据号")]
            public string InDocsNo { get; set; }
            [Description("入库单据行号")]
            public string InDocsRowNo { get; set; }
            [Description("供应商编码")]
            public string SuppCode { get; set; }
            [Description("供应商名称")]
            public string SuppName { get; set; }
            [Description("仓库名称")]
            public string WareHouseName { get; set; }
            [Description("总重量")]
            public decimal TotalWtQty { get; set; }
            [Description("净重")]
            public decimal NetWQty { get; set; }
            [Description("皮重")]
            public decimal TareWQty { get; set; }
            [Description("长度")]
            public decimal LengthQty { get; set; }
            [Description("生产批号")]
            public string BatchNo { get; set; }
            [Description("生产时间")]
            public DateTime ProductTime { get; set; }
            [Description("第一次入库时间")]
            public DateTime OneInTime { get; set; }
            [Description("RFID条码")]
            public string RFIDBarCode { get; set; }
            [Description("工字轮规格")]
            public string HWSpec { get; set; }
            [Description("改手盘标记")]
            public bool IsSurplus { get; set; }
            [Description("返工标记")]
            public bool IsRework { get; set; }
            [Description("快投标记")]
            public bool IsFast { get; set; }
            [Description("是否异常")]
            public bool IsFail { get; set; }
            [Description("异常原因")]
            public string FailReason { get; set; }
            [Description("等级")]
            public string Grade { get; set; }
            [Description("是否退料")]
            public bool IsBack { get; set; }
            [Description("退料原因")]
            public string BackReason { get; set; }
            [Description("备注")]
            public string Remark { get; set; }
            [Description("巷道")]
            public string Tunnel { get; set; }
            [Description("物料编码")]
            public string MatCode { get; set; }
            [Description("单/双丝")]
            public string SilkType { get; set; }
            [Description("货位号")]
            public string Location { get; set; }
            [Description("操作状态")]
            public string ExecState { get; set; }
            [Description("执行单据号")]
            public string ExecDocsNo { get; set; }
            [Description("执行单据行号")]
            public string ExecDocsRowNo { get; set; }
            [Description("执行单据类型代码")]
            public string ExecDocsTypeCode { get; set; }
            [Description("物料名称")]
            public string MatName { get; set; }
            [Description("货位是否启用")]
            public int RowStop { get; set; }
            [Description("生产机台号")]
            public string ProductWbNo { get; set; }
            [Description("生产产线号")]
            public string ProductLineNo { get; set; }
            [Description("出库状态")]
            public string OutStatus { get; set; }
            [Description("入库状态")]
            public string InStatus { get; set; }
            [Description("货位名称")]
            public string LocationName { get; set; }
        }
        /// <summary>
        /// 库龄报表
        /// </summary>
        public class InventoryAgingReportResponse
        {
            [Description("库龄")]
            public decimal Age { get; set; }
            [Description("时效时间")]
            public decimal HoldDuration { get; set; }
            [Description("生产时间")]
            public DateTime ProductTime { get; set; }
            [Description("第一次入库时间")]
            public DateTime OneInTime { get; set; }
            [Description("RFID条码")]
            public string RFIDBarCode { get; set; }
            [Description("工字轮型号")]
            public string HWSpec { get; set; }
            [Description("物料等级")]
            public string Grade { get; set; }
            [Description("到期日")]
            public DateTime Duedate { get; set; }
            [Description("剩余天数")]
            public decimal Remaindays { get; set; }
            [Description("巷道")]
            public string Tunnel { get; set; }
            [Description("物料编码")]
            public string MatCode { get; set; }
            [Description("物料名称")]
            public string MatName { get; set; }
        }
    }
}
