﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.pt
{
    public class PurchaseBillTransReqest:BaseRequest
    {
        /// <summary>
        /// 单号
        /// </summary>
        public string BillCode { get; set; }
        /// <summary>
        /// 供应商编码
        /// </summary>
        public string SupCode { get; set; }
        /// <summary>
        /// 供应商名称
        /// </summary>
        public string SupName { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        [Required(ErrorMessage = "{0} 单据类型不可为空")]
        public string BillType { get; set; }
        /// <summary>
        /// 过账凭证号
        /// </summary>
        public string ReqId { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 仓库编码不可为空")]
        public string WareCode { get; set; }
        /// <summary>
        /// 盘条信息列表
        /// </summary>
        public List<ListInfoItem> ListInfo { get; set; }
    }
    public class ListInfoItem
    {
        /// <summary>
        /// RFID
        /// </summary>
        public string RFID { get; set; }
        /// <summary>
        /// 盘条条码
        /// </summary>
        public string RodBar { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 炉号
        /// </summary>
        public string BoilerNo { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 包号
        /// </summary>
        public string PackNo { get; set; }
        /// <summary>
        /// 生产批号
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 碳当量
        /// </summary>
        public decimal Carbon { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        public DateTime ProductDate { get; set; }
        /// <summary>
        /// 牌号
        /// </summary>
        public string Brand { get; set; }
        /// <summary>
        /// 规格
        /// </summary>
        public string Describe { get; set; }
        /// <summary>
        /// 执行标准
        /// </summary>
        public string ExecStandard { get; set; }
        /// <summary>
        /// 许可证号
        /// </summary>
        public string Licence { get; set; }
        /// <summary>
        /// 包重
        /// </summary>
        public decimal Weight { get; set; }
        /// <summary>
        /// 时效期
        /// </summary>
        public decimal HoldDuration { get; set; }
        /// <summary>
        /// 预留字段1
        /// </summary>
        public string Default1 { get; set; }
        /// <summary>
        /// 预留字段2
        /// </summary>
        public string Default2 { get; set; }
        /// <summary>
        /// 预留字段3
        /// </summary>
        public string Default3 { get; set; }
    }
}
