﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.share
{
    public class GenAgvSchedulingTaskRequest
    {
        /// <summary>
        /// 请求编号，每个请求都要一个唯一编号， 同一个请求重复提交， 使用同一编号。
        /// </summary>
        public string reqCode { get; set; }
        /// <summary>
        /// 请求时间截 格式: “yyyy-MM-dd HH:mm:ss”
        /// </summary>
        public string reqTime { get; set; }
        /// <summary>
        /// 客户端编号，如PDA，HCWMS等
        /// </summary>
        public string clientCode { get; set; }
        /// <summary>
        /// 令牌号, 由调度系统颁发
        /// </summary>
        public string tokenCode { get; set; }
        /// <summary>
        /// 任务类型
        /// </summary>
        public string taskTyp { get; set; }
        /// <summary>
        /// 容器类型（叉车/CTU专用）叉车项目必传
        /// </summary>
        public string ctnrTyp { get; set; }
        /// <summary>
        /// 任务模式
        /// </summary>
        public string taskMode { get; set; }
        /// <summary>
        /// 工作位
        /// </summary>
        public string wbCode { get; set; }
        /// <summary>
        /// 位置路径
        /// </summary>
        public List<positionCodeClass> positionCodePath { get; set; }
        /// <summary>
        /// 货架编号
        /// </summary>
        public string podCode { get; set; }
        /// <summary>
        /// “180”,”0”,”90”,”-90”
        /// </summary>
        public string podDir { get; set; }
        /// <summary>
        /// 货架类型, 传空时表示随机找个货架
        /// </summary>
        public string podTyp { get; set; }
        /// <summary>
        /// 物料批次或货架上的物料唯一编码
        /// </summary>
        public string materialLot { get; set; }
        /// <summary>
        /// 优先级，从（1~127）级，最大优先级最高
        /// </summary>
        public string priority { get; set; }
        /// <summary>
        /// 任务单号,选填, 不填系统自动生成，UUID小于等于64位
        /// </summary>
        public string taskCode { get; set; }
        /// <summary>
        /// AGV编号，填写表示指定某一编号的AGV执行该任务
        /// </summary>
        public string agvCode { get; set; }
        /// <summary>
        /// 组编号
        /// </summary>
        public string groupId { get; set; }
        /// <summary>
        /// 自定义字段.JSON格式 
        /// </summary>
        public string data { get; set; }
    }
    public class positionCodeClass
    {
        public string positionCode { get; set; }
        public string type { get; set; }
    }
}
