﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.response.fj
{
    /// <summary>
    ///  agv上报状态反馈信息
    /// </summary>
    public class AgvCallbackResponse
    {
        /// <summary>
        /// 返回码 1:允许执行 0:不允许执行
        /// </summary>
        public string code { get; set; } = "0";

        /// <summary>
        /// 返回消息
        /// </summary>
        public string message { get; set; } = "成功";

        /// <summary>
        /// 请求编号
        /// </summary>
        public string reqCode { get; set; }
    }

    /// <summary>
    ///  AGV 返回结果code值枚举
    /// </summary>
    public class AgvResponseCode
    {
        /// <summary>
        ///  成功
        /// </summary>
        public static string Success { get; set; } = "0";

        /// <summary>
        ///  失败
        /// </summary>
        public static string Fail { get; set; } = "1";

        /// <summary>
        ///  重复提交
        /// </summary>
        public static string Repeat { get; set; } = "6";

        /// <summary>
        ///  失败，未知异常
        /// </summary>
        public static string Error { get; set; } = "99";
    }
}
