﻿using Microsoft.Extensions.Logging;
using System;
using wms.service.Service;

namespace wms.service.Extensions
{
    /// <summary>
    ///  专注于扩展基础数据类型（如整数、字符串等）
    /// </summary>
    public static class PrimitiveTypeExtensions
    {
        /// <summary>
        ///  获取时间
        /// </summary>
        /// <param name="time">数据源</param>
        /// <returns></returns>
        public static DateTime GetDateTime(this string time) => GetDateTime(time, null);

        /// <summary>
        ///  获取时间
        /// </summary>
        /// <param name="time">数据源</param>
        /// <param name="logger">日志服务</param>
        /// <returns></returns>
        public static DateTime GetDateTime(this string time, ILogger<FJService> logger)
        {
            DateTime prodate = DateTime.Now;
            DateTime item = prodate;
            if (DateTime.TryParseExact(time, "yyyyMMddHHmmss", null, System.Globalization.DateTimeStyles.None, out prodate)) prodate = DateTime.ParseExact(time, "yyyyMMddHHmmss", null);
            else if (DateTime.TryParseExact(time, "yyyy-MM-dd HH:mm:ss", null, System.Globalization.DateTimeStyles.None, out prodate)) prodate = DateTime.ParseExact(time, "yyyy-MM-dd HH:mm:ss", null);
            else
            {
                if (logger != null)
                {
                    logger.LogInformation("生产日期格式不对,系统默认使用当前时间");
                }

                prodate = item;
            }

            return prodate;
        }
    }
}