﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Text;
using WCS.Entity;
using WCS.Entity.hj;
using wms.dto.request;
using wms.dto.request.hj;
using wms.dto.request.hj.dto;
using wms.dto.request.share;
using wms.dto.response;
using wms.dto.response.hj;
using wms.sqlsugar.model;
using wms.sqlsugar.model.hj;
using static wms.dto.request.hj.dto.ReportResponse;

namespace wms.service.IService
{
    public interface IHJService
    {
        public string GetSysConfigContentByCode(string code);
        public SRes SyncMaterInfo(HJSyncMaterInfoListRequest ResData);
        //public bool Add(hjBillDt data1);
        public hjSysConfig GetSysConfigByCode(string code);
        hjSysConfig GetSysConfigByExpression(Expression<Func<hjSysConfig, bool>> WhereExpression);
        hjBaseMater GetBaseMaterByExpression(Expression<Func<hjBaseMater, bool>> WhereExpression);
        /// <summary>
        /// 获取反馈信息列表
        /// </summary>
        /// <param name="WhereExpression"></param>
        /// <returns></returns>
        List<hjBillFeedbackPush> GetBillFeedbackList(Expression<Func<hjBillFeedbackPush, bool>> WhereExpression);
        /// <summary>
        /// 获取反馈信息
        /// </summary>
        /// <param name="WhereExpression"></param>
        /// <returns></returns>
        public List<BillPushinfo> GetBillFeedbackList1(Expression<Func<BillPushinfo, bool>> WhereExpression);
        SRes<ApplyStockInLocResponse> ApplyStockInLoc(ApplyStockInLocRequest reqEntity);
        SRes<int> CompleteTask(CompleteTaskRequest reqDto);
        public SRes<int> SrmPickOutCompleted(SrmPickOutCompletedRequest reqDto);
        bool UpdateBillFeedbackPushModelColumns(UpdateModelColumns<hjBillFeedbackPush> updateModel);
        bool UpdateSysConfigModelColumns(UpdateModelColumns<hjSysConfig> updateModel);
        public SRes<bool> DeleteDoc(Expression<Func<hjBillDocument, bool>> whereExpression);
        public SRes CopperLineReceiveInstr(CopperLineRequest reqDto);
        public SRes PdaCopperLineReceiveInstr(CopperLineRequest reqDto);
        ApplyStockOutTaskResponse ApplyEmptySpoolService(ApplyEmptySpoolRequest request);
        SRes<AddWcsMoveTaskResponse> AddWcsMoveTask(AddWcsMoveTaskRequest reqEntity);
        RfidCheckDiffResponse RfidCheckDiffService(RfidCheckDiffRequest request);
        SRes WetLineBackInApplyService(WetLineBackInApplyRequest request);
        StockChangeResponse StockChange(StockChangeRequest reqDto);
        GetCurStockListResponse GetCurStockList(GetCurStockListRequest reqDto);
        SpecialPickMaterApplyResponse SpecialPickMaterApply(SpecialPickMaterApplyRequest reqDto);
        SRes WetLinePickMaterApplyService(WetLinePickMaterApplyRequest request);
        string AddJob(AddJobRequest request);
        string UpdateJobEntity(AddJobRequest request);
        AddJobRequest GetSysJobById(long id);
        List<SysJobApiRelation> GetSysApiDetail(long Id);
        SRes<int> WcsTaskCallBack(WcsTaskCallBackRequest reqEntity);
        SRes<DocumentsResponse> GetPageDocumentsList(DocumentsRequest request);
        string FinishDocument(DetailRequest request);
        SRes<RealTimeInventoryReportResponse> GetPageStockdetailList(StockRequest request);
        string ManualTask(ManualTaskRequest request);
        List<ExportModel> Exportrow(string code);
        SRes<int> Unbounding(UnboundRequest request);
        SRes<DocumentsdetailList> GetDocumentDetailListByDocsNo(DocumentsRequest request);
        SRes<MaterInfo> MaterInfoByRfid(PdaRfidRequest request);
        string PdaGroupStock(PdaRfidRequest request);
        string PdaInsertTask(PdaRfidRequest request);
        SRes<string> GetTunnelPriorityList(GetTunnelPriorityListRequest reqEntity);
        List<BillPushinfo> GetPushDatelistAuto(PushDate request);
        bool UpdatePushModelColumns(UpdateModelColumns<BillPushinfo> updateModel);
        SRes WcsUploadInfo(WcsUploadInfoRequest reqDto);
        SRes<GetTunnelEmptyConResponse> GetTunnelEmptyConCount(GetTunnelEmptyConCountRequest reqDto);
        string AgvCarryTaskInfo(AgvTaskInfoRequest request);
        //SRes CancelTaskVerify(CancelTaskRequest request);
        //SRes CarryTaskInfo(CancelTaskRequest request);
        /// <summary>
        /// 获取一小时里的出库锁货位
        /// </summary>
        /// <returns></returns>
        List<BaseWarecell> GetOutStateList();
        List<WCS_TaskOld> GetTaskHistoryByCode(List<string> codes);
        SRes ForceCancelTask(WebErrorRequest request);
        SRes DeleteStockInfo(DetailCodeRequest request);
        SRes UpdateStockState(DetailCodeRequestdto request);
        SRes UpdateCellState(DetailCodeRequestdto request);
        SRes DataSwapCell(DataSwapCellRequest request);
        List<BillPushinfo> GetPushDatelistMannel(PushDate request);
        SRes DataBasePatch(DetailCodeRequest request);
    }
}
