﻿using WCS.Entity;
using WCS.Entity.hj;
using wms.service.IService;
using wms.sqlsugar;
using wms.sqlsugar.model;
using wms.sqlsugar.model.cp;
using wms.sqlsugar.model.hj;
using wms.sqlsugar.model.pt;
using wms.sqlsugar.model.sx;

namespace wms.service.Service
{
    public class DBService : IDBService
    {
        public void InitPtDB()
        {
            var db1 = SqlSugarHelper.Db.GetConnectionScopeWithAttr<ptBillPushinfo>();
            db1.DbMaintenance.CreateDatabase();
            db1.CodeFirst.InitTables<ptBaseMater>();
            db1.CodeFirst.InitTables<ptBaseCustinfo>();
            db1.CodeFirst.InitTables<ptSysConfig>();
            db1.CodeFirst.InitTables<ptBaseMatgrp>();
            db1.CodeFirst.InitTables<ptBaseSuppinfo>();
            db1.CodeFirst.InitTables<ptBaseUnitgrp>();
            db1.CodeFirst.InitTables<ptBaseUnitinfo>();
            db1.CodeFirst.InitTables<ptBaseUnitrate>();
            db1.CodeFirst.InitTables<ptBaseWarehouse>();
            db1.CodeFirst.InitTables<ptBaseWareZone>();
            db1.CodeFirst.InitTables<ptBaseWareLocation>();
            db1.CodeFirst.InitTables<ptBaseWarerule>();
            db1.CodeFirst.InitTables<ptBaseContainer>();

            db1.CodeFirst.InitTables<ptBillBominfo>();
            db1.CodeFirst.InitTables<ptBillBomsetgrp>();
            db1.CodeFirst.InitTables<ptBillBomsetinfo>();
            db1.CodeFirst.InitTables<ptBillDocsinfo>();
            db1.CodeFirst.InitTables<ptBillInvinit>();
            db1.CodeFirst.InitTables<ptBillInvnow>();
            db1.CodeFirst.InitTables<ptBillLog>();
            db1.CodeFirst.InitTables<ptBillPushinfo>();
            db1.CodeFirst.InitTables<ptBillMachinfo>();
            db1.CodeFirst.InitTables<ptBillPboxrule>();
            //db1.CodeFirst.InitTables<ptWCS_TaskInfo>();
            db1.CodeFirst.InitTables<ptSysJob>();
            db1.CodeFirst.InitTables<ptSysJobApiRelation>();
            db1.CodeFirst.InitTables<ptBillInvFlow>();
            db1.CodeFirst.InitTables<ptBillMesmiddle>();
        }

        public void InitHjDB()
        {
            var db1 = SqlSugarHelper.Db.GetConnectionScopeWithAttr<BillPushinfo>();
            db1.DbMaintenance.CreateDatabase();
            //db1.CodeFirst.InitTables<hjBaseMater>();
            //db1.CodeFirst.InitTables<hjSysConfig>();
            //db1.CodeFirst.InitTables<hjBaseMaterGroup>();
            //db1.CodeFirst.InitTables<hjBaseWarehouse>();
            //db1.CodeFirst.InitTables<hjBaseWareZone>();
            //db1.CodeFirst.InitTables<hjBaseWareLocation>();
            //db1.CodeFirst.InitTables<hjBillBarcode>();
            //db1.CodeFirst.InitTables<hjBillDocument>();
            //db1.CodeFirst.InitTables<hjBillFeedbackPush>();
            //db1.CodeFirst.InitTables<hjBillContainer>();
            //db1.CodeFirst.InitTables<hjBillInventory>();
            //db1.CodeFirst.InitTables<hjBillTask>();
            //db1.CodeFirst.InitTables<hjBillTaskHistory>();
            //db1.CodeFirst.InitTables<hjSysJob>();
            //db1.CodeFirst.InitTables<hjSysJobApiRelation>();
            //db1.CodeFirst.InitTables<ptBaseContainer>();
            //db1.CodeFirst.InitTables<hjBillInvFlow>();
            //db1.CodeFirst.InitTables<hjBaseSerialnoRule>();
            //db1.CodeFirst.InitTables<hjBaseUnits>();
            db1.CodeFirst.InitTables<BillPushinfo>();
            db1.CodeFirst.InitTables<BaseContinfo>();
            db1.CodeFirst.InitTables<BaseCustinfo>();
            db1.CodeFirst.InitTables<BaseMatgrp>();
            db1.CodeFirst.InitTables<BaseMatinfo>();
            db1.CodeFirst.InitTables<BaseSuppinfo>();
            db1.CodeFirst.InitTables<BaseUnitgrp>();
            db1.CodeFirst.InitTables<BaseUnitinfo>();
            db1.CodeFirst.InitTables<BaseUnitrate>();
            db1.CodeFirst.InitTables<BaseWarearea>();
            db1.CodeFirst.InitTables<BaseWarecell>();
            db1.CodeFirst.InitTables<BaseWarehouse>();
            db1.CodeFirst.InitTables<BaseWarerule>();
            db1.CodeFirst.InitTables<BillBominfo>();
            db1.CodeFirst.InitTables<BillBomsetgrp>();
            db1.CodeFirst.InitTables<BillBomsetinfo>();
            db1.CodeFirst.InitTables<BillDocsinfo>();
            db1.CodeFirst.InitTables<BillInvflow>();
            db1.CodeFirst.InitTables<BillInvinit>();
            db1.CodeFirst.InitTables<BillInvnow>();
            db1.CodeFirst.InitTables<BillLog>();
            db1.CodeFirst.InitTables<BillMachinfo>();
            db1.CodeFirst.InitTables<BillPboxrule>();
            db1.CodeFirst.InitTables<WCS_TaskInfo>();
            //db1.CodeFirst.InitTables<WCS_TaskOld>();
            db1.CodeFirst.InitTables<SysJob>();
            db1.CodeFirst.InitTables<SysJobApiRelation>();
        }

        public void InitFjDB()
        {
            var db1 = SqlSugarHelper.Db.GetConnectionScopeWithAttr<sqlsugar.model.fj.BillPushinfo>();
            db1.DbMaintenance.CreateDatabase();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseContinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseCustinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseMatgrp>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseMatinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseSuppinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseUnitgrp>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseUnitinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseUnitrate>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseWarearea>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseWarecell>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseWarehouse>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BaseWarerule>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillBominfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillBomsetgrp>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillBomsetinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillDocsinfo>();

            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillInvflow>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillInvinit>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillInvnow>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillLog>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillPushinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillSpoolTrans>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillMachinfo>();
            //db1.CodeFirst.InitTables<sqlsugar.model.fj.BillRingPalletizingInfo>();
            db1.CodeFirst.InitTables<sqlsugar.model.fj.BillPaiKu>();
        }

        public void InitSxDB()
        {
            var db1 = SqlSugarHelper.Db.GetConnectionScopeWithAttr<sxBillDocument>();
            db1.DbMaintenance.CreateDatabase();
            db1.CodeFirst.InitTables<sxBaseMater>();
            db1.CodeFirst.InitTables<sxSysConfig>();
            db1.CodeFirst.InitTables<sxBaseMaterGroup>();
            db1.CodeFirst.InitTables<sxBaseWarehouse>();
            db1.CodeFirst.InitTables<sxBaseWareZone>();
            db1.CodeFirst.InitTables<sxBaseWareLocation>();
            db1.CodeFirst.InitTables<sxBillBarcode>();
            db1.CodeFirst.InitTables<sxBillBomInfo>();
            db1.CodeFirst.InitTables<sxBillDocument>();
            db1.CodeFirst.InitTables<sxBillFeedbackPush>();
            db1.CodeFirst.InitTables<sxBillContainer>();
            db1.CodeFirst.InitTables<sxBillInventory>();
            db1.CodeFirst.InitTables<sxBillMachineInfo>();
            db1.CodeFirst.InitTables<sxBillProductPackRule>();
            db1.CodeFirst.InitTables<sxBillTask>();
            db1.CodeFirst.InitTables<sxBillTaskHistory>();
            db1.CodeFirst.InitTables<sxBillWetStack>();
            db1.CodeFirst.InitTables<sxBillWetStackDetail>();
            db1.CodeFirst.InitTables<sxSysJob>();
            db1.CodeFirst.InitTables<sxSysJobApiRelation>();
            db1.CodeFirst.InitTables<sxBaseContainer>();
            db1.CodeFirst.InitTables<sxBillInvFlow>();
        }

        public void InitCpDB()
        {
            var db1 = SqlSugarHelper.Db.GetConnectionScopeWithAttr<cpBillDocument>();
            db1.DbMaintenance.CreateDatabase();
            db1.CodeFirst.InitTables<cpBaseMater>();
            db1.CodeFirst.InitTables<cpSysConfig>();
            db1.CodeFirst.InitTables<cpBaseMaterGroup>();
            db1.CodeFirst.InitTables<cpBaseWarehouse>();
            db1.CodeFirst.InitTables<cpBaseWareZone>();
            db1.CodeFirst.InitTables<cpBaseWareLocation>();
            db1.CodeFirst.InitTables<cpBillBarcode>();
            db1.CodeFirst.InitTables<cpBillDocument>();
            db1.CodeFirst.InitTables<cpBillFeedbackPush>();
            db1.CodeFirst.InitTables<cpBillContainer>();
            db1.CodeFirst.InitTables<cpBillInventory>();
            db1.CodeFirst.InitTables<cpBillProductPackRule>();
            db1.CodeFirst.InitTables<cpBillTask>();
            db1.CodeFirst.InitTables<cpBillTaskHistory>();
            db1.CodeFirst.InitTables<cpSysJob>();
            db1.CodeFirst.InitTables<cpSysJobApiRelation>();
            db1.CodeFirst.InitTables<cpBaseContainer>();
            db1.CodeFirst.InitTables<cpBillInvFlow>();
        }
    }
}
