﻿using AutoMapper;
using System;
using WCS.Entity;
using WCS.Entity.hj;
using wms.dto.request;
using wms.dto.request.fj;
using wms.dto.request.hj;
using wms.dto.request.hj.dto;
using wms.dto.request.pt;
using wms.dto.request.share;
using wms.dto.response;
using wms.dto.response.fj;
using wms.dto.response.pt.dto;
using wms.sqlsugar.model.hj;
using wms.sqlsugar.model.pt;
using static wms.dto.request.hj.dto.ReportResponse;

namespace wms.service.mapper
{
    public class WmsPrifile : Profile
    {
        public WmsPrifile()
        {
            CreateMap<HJSyncMaterInfoResponseItem, hjBaseMater>()
                .ForMember(dest => dest.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(dest => dest.HeadTypeCode, opt => opt.MapFrom(src => src.HeadTypeCode))

                ;
            CreateMap<hjBillFeedbackPush, CopperLineStockInFeedBackItem>();
            CreateMap<hjBillFeedbackPush, WetLineBackInFeedBackRequestItem>();
            CreateMap<hjBillFeedbackPush, SpecialPickMaterFeedBackRequest>();
            CreateMap<hjBillFeedbackPush, SpecialPickMaterFeedBackRequestItem>();
            CreateMap<BillPushinfo, MoveStockFeedBackRequestItem>()
                .ForMember(dest => dest.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(dest => dest.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(dest => dest.StartLoc, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(dest => dest.EndLoc, opt => opt.MapFrom(src => src.Memo))
                .ForMember(dest => dest.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                ;
            CreateMap<BillInvinit, BillInvnow>();
            CreateMap<BillInvnow, BillInvflow>();
            CreateMap<BillInvflow, BillInvnow>();
            CreateMap<WCS_TaskInfo, WCS_TaskOld>();

            CreateMap<CopperLineRequest, HjMaterialStockInRequest>();

            CreateMap<WetLineBackInApplyRequest, HjMaterialStockInRequest>();
            CreateMap<SysJob, dto.response.hj.SysJobDto>();
            CreateMap<sqlsugar.model.fj.fjSysJob, dto.response.hj.SysJobDto>();
            
            #region 分拣

            CreateMap<FJBuildEmptyPalletsStockRequest, FJBuildEmptyPalletsStockDto>();
            CreateMap<SRes, CopperLineResponse>();
            CreateMap<sqlsugar.model.fj.BillInvinit, sqlsugar.model.fj.BillInvnow>();
            CreateMap<sqlsugar.model.fj.BillInvnow, sqlsugar.model.fj.BillInvflow>();
            CreateMap<sqlsugar.model.fj.BillInvflow, sqlsugar.model.fj.BillInvnow>();
            CreateMap<WCS.Entity.fj.WCS_TaskInfo, WCS.Entity.fj.WCS_TaskOld>();
            CreateMap<sqlsugar.model.fj.BillInvflow, sqlsugar.model.fj.BillInvnow>();

            #endregion 分拣

            CreateMap<BillPushinfo, ListInfoInfo>()
                .ForMember(p => p.SpoolCode, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.MatCode, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.TolWeight, opt => opt.MapFrom(src => src.TolWQty))
                .ForMember(p => p.NetWeight, opt => opt.MapFrom(src => src.NetWQty))
                .ForMember(p => p.TareWeight, opt => opt.MapFrom(src => src.TareWQty))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => src.WarehouseCode));

            CreateMap<BillPushinfo, WetLineBackInFeedBackRequestItem>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.MatCode, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Weight, opt => opt.MapFrom(src => src.NetWQty))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => "合金库"));

            //定时任务模块映射
            CreateMap<AddJobRequest, SysJob>();
            CreateMap<JobApiRelation, SysJobApiRelation>();
            CreateMap<SysJobApiRelation, JobApiRelation>();

            CreateMap<TunnelStatusEntity, TunnelStatusEntity>();

            CreateMap<HJSyncMaterInfoListRequestItem, HJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoListRequestItem, FJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoListRequestItem, BaseMatinfo>();
            CreateMap<HJSyncMaterInfoListRequestItem, BaseMatinfo>()
                 .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.Leafcode, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.LeafName, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.HeadCode, opt => opt.MapFrom(src => src.HeadTypeCode))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))
                .ForMember(p => p.WeightUnit, opt => opt.MapFrom(src => src.WeightUnit))
                ;

            CreateMap<UpdateMaterEntity, UpdateMaterEntity>();
            //任务
            CreateMap<hjBillTask, TaskRsponse>();
            CreateMap<TaskRsponse, hjBillTask>();
            CreateMap<hjBillTaskHistory, hjBillTask>();
            CreateMap<hjBillTask, hjBillTaskHistory>();
            //单据
            CreateMap<DocumentsResponse, hjBillDocument>();

            //库存
            CreateMap<RealTimeInventoryReportResponse, RealTimeInventoryReportResponse>();
            CreateMap<ExportModel, ExportModel>();

            CreateMap<MaterInfo, MaterInfo>();

            #region 盘条库映射

            CreateMap<ptWCS_TaskInfo, PtTaskRsponse>();
            CreateMap<PtTaskRsponse, ptWCS_TaskInfo>();
            CreateMap<ptWCS_TaskInfo, ptWCS_TaskInfo>();
            CreateMap<ptWCS_TaskOld, ptWCS_TaskInfo>();
            CreateMap<ptWCS_TaskInfo, ptWCS_TaskOld>();

            CreateMap<ptBillInvinit, ptBillInvnow>();
            CreateMap<ptBillInvnow, ptBillInvinit>();
            CreateMap<ptBillInvnow, ptBillInvFlow>();
            CreateMap<ptBillInvFlow, ptBillInvnow>();

            //CreateMap<PTSyncMaterInfoListRequestItem, ptBaseMater>();
            CreateMap<PtSyncMaterInfoListRequest, ptBaseMater>()
                 .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.MatShortDesc))
                .ForMember(p => p.FullDesc, opt => opt.MapFrom(src => src.MatFullDesc))
                .ForMember(p => p.ExtDesc, opt => opt.MapFrom(src => src.MatExtDesc))
                .ForMember(p => p.Enname, opt => opt.MapFrom(src => src.MatEnName))
                .ForMember(p => p.Leafcode, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.LeafName, opt => opt.MapFrom(src => src.LeafTypeName))
                .ForMember(p => p.MidCode, opt => opt.MapFrom(src => src.MidTypeCode))
                .ForMember(p => p.MidName, opt => opt.MapFrom(src => src.MidTypeName))
                .ForMember(p => p.HeadCode, opt => opt.MapFrom(src => src.HeadTypeCode))
                .ForMember(p => p.HeadName, opt => opt.MapFrom(src => src.HeadTypeName))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.Texture, opt => opt.MapFrom(src => src.Texture))
                .ForMember(p => p.FigureNo, opt => opt.MapFrom(src => src.FigureNo))
                .ForMember(p => p.ComCode, opt => opt.MapFrom(src => src.ComCode))
                .ForMember(p => p.ComName, opt => opt.MapFrom(src => src.ComName))
                .ForMember(p => p.CalcUnit, opt => opt.MapFrom(src => src.CalcUnit))
                .ForMember(p => p.StockUnit, opt => opt.MapFrom(src => src.StockUnit))
                .ForMember(p => p.Weight, opt => opt.MapFrom(src => src.Weight))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.EditTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))
                .ForMember(p => p.WeightUnit, opt => opt.MapFrom(src => src.WeightUnit))
                ;

            CreateMap<ptBillPushinfo, PurchaseBillTransFeedBackRequestItem>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.RodBar, opt => opt.MapFrom(src => src.RodBarCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => "盘条库"));

            #endregion 盘条库映射

            CreateMap<FJSyncMaterInfoListRequestItem, FJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoResponseItem, wms.sqlsugar.model.fj.BaseMatinfo>()
                .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.ProCode, opt => opt.MapFrom(src => src.ProCode))
                .ForMember(p => p.ProName, opt => opt.MapFrom(src => src.ProName))
                .ForMember(p => p.ProStre, opt => opt.MapFrom(src => src.ProStre))
                .ForMember(p => p.LinearMax, opt => opt.MapFrom(src => src.LinearMax))
                .ForMember(p => p.LinearMin, opt => opt.MapFrom(src => src.LinearMin))
                .ForMember(p => p.LinearTar, opt => opt.MapFrom(src => src.LinearTar))
                .ForMember(p => p.Plating, opt => opt.MapFrom(src => src.Plating))
                .ForMember(p => p.Mono, opt => opt.MapFrom(src => src.Mono))
                .ForMember(p => p.PlatingWeight, opt => opt.MapFrom(src => src.PlatingWeight))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration));

            CreateMap<SxSyncMaterInfoListRequestItem, wms.sqlsugar.model.fj.BaseMatinfo>()
                .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.ProCode, opt => opt.MapFrom(src => src.ProCode))
                .ForMember(p => p.ProName, opt => opt.MapFrom(src => src.ProName))
                .ForMember(p => p.ProStre, opt => opt.MapFrom(src => src.ProStre))
                .ForMember(p => p.LinearMax, opt => opt.MapFrom(src => src.LinearMax))
                .ForMember(p => p.LinearMin, opt => opt.MapFrom(src => src.LinearMin))
                .ForMember(p => p.LinearTar, opt => opt.MapFrom(src => src.LinearTar))
                .ForMember(p => p.Plating, opt => opt.MapFrom(src => src.Plating))
                .ForMember(p => p.PlatingWeight, opt => opt.MapFrom(src => src.PlatingWeight))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration));

            CreateMap<FJSyncMaterInfoResponseItem, SxSyncMaterInfoListRequestItem>();


            CreateMap<wms.sqlsugar.model.fj.BillPushinfo, WetProductStockInFeedBackRequestItem>();


            CreateMap<SyncMachineInfoRequest, wms.sqlsugar.model.fj.BillMachinfo>()
           .ForMember(p => p.MachNo, opt => opt.MapFrom(src => src.MachineCode))
           .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MachineName))
           .ForMember(p => p.Direction, opt => opt.MapFrom(src => src.VehicleDirection))
           .ForMember(p => p.MacTypeCode, opt => opt.MapFrom(src => src.MachineTypeCode))
           .ForMember(p => p.MacTypeName, opt => opt.MapFrom(src => src.MachineTypeName)) ;
            
        }
    }
}
