﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Text;

namespace wms.sqlsugar.model.cp
{
    [Tenant("cp")]
    [SugarTable("base_mater", "物料基础信息表")]
    public class cpBaseMater : BaseModel
    {
        /// <summary>
        /// 物料编码
        /// </summary>
        [SugarColumn(ColumnName = "code", ColumnDataType = "nvarchar", Length = 50)]
        public string Code { get; set; }
        /// <summary>
        /// 物料名称
        /// </summary>
        [SugarColumn(ColumnName = "name", ColumnDataType = "nvarchar", Length = 200)]
        public string Name { get; set; }
        /// <summary>
        /// 物料短描述
        /// </summary>
        [SugarColumn(ColumnName = "short_desc", ColumnDataType = "nvarchar", Length = 100,IsNullable = true)]
        public string ShortDesc { get; set; }
        /// <summary>
        /// 物料长描述
        /// </summary>
        [SugarColumn(ColumnName = "full_desc", ColumnDataType = "nvarchar", Length = 500, IsNullable = true)]
        public string FullDesc { get; set; }
        /// <summary>
        /// 物料补充描述
        /// </summary>
        [SugarColumn(ColumnName = "ext_desc", ColumnDataType = "nvarchar", Length = 500, IsNullable = true)]
        public string MatExtDesc { get; set; }
        /// <summary>
        /// 物料英文名
        /// </summary>
        [SugarColumn(ColumnName = "en_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string MatEnName { get; set; }
        /// <summary>
        /// 物料组Id
        /// </summary>
        [SugarColumn(ColumnName = "mater_group_id")]
        public long MaterGroupId { get; set; }
        /// <summary>
        /// 叶类代码
        /// </summary>
        [SugarColumn(ColumnName = "leaf_type_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string LeafTypeCode { get; set; }
        /// <summary>
        /// 叶类名称
        /// </summary>
        [SugarColumn(ColumnName = "leaf_type_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string LeafTypeName { get; set; }
        /// <summary>
        /// 中类代码
        /// </summary>
        [SugarColumn(ColumnName = "mid_type_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string MidTypeCode { get; set; }
        /// <summary>
        /// 中类名称
        /// </summary>
        [SugarColumn(ColumnName = "mid_type_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string MidTypeName { get; set; }
        /// <summary>
        /// 大类代码
        /// </summary>
        [SugarColumn(ColumnName = "head_type_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string HeadTypeCode { get; set; }
        /// <summary>
        /// 大类名称
        /// </summary>
        [SugarColumn(ColumnName = "head_type_name", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string HeadTypeName { get; set; }
        /// <summary>
        /// 规格型号
        /// </summary>
        [SugarColumn(ColumnName = "describe", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string Describe { get; set; }
        /// <summary>
        /// 材质
        /// </summary>
        [SugarColumn(ColumnName = "texture", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string Texture { get; set; }
        /// <summary>
        /// 图号
        /// </summary>
        [SugarColumn(ColumnName = "figureNo", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string FigureNo { get; set; }
        /// <summary>
        /// 强度
        /// </summary>
        [SugarColumn(ColumnName = "strength", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string Strength { get; set; }
        /// <summary>
        /// 镀层
        /// </summary>
        [SugarColumn(ColumnName = "plating", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string Plating { get; set; }
        /// <summary>
        /// 镀层克重
        /// </summary>
        [SugarColumn(ColumnName = "plating_weight", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal PlatingWeight { get; set; }
        /// <summary>
        /// 镀层主元素含量
        /// </summary>
        [SugarColumn(ColumnName = "plating_con_qty", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal PlatingConQty { get; set; }
        /// <summary>
        /// 线密度
        /// </summary>
        [SugarColumn(ColumnName = "linear", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal Linear { get; set; }
        /// <summary>
        /// 产品号
        /// </summary>
        [SugarColumn(ColumnName = "pro_code", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string ProCode { get; set; }
        /// <summary>
        /// 产品描述
        /// </summary>
        [SugarColumn(ColumnName = "pro_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string ProName { get; set; }
        /// <summary>
        /// 产品强度
        /// </summary>
        [SugarColumn(ColumnName = "pro_stre", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string ProStre { get; set; }
        /// <summary>
        /// 线密度上限
        /// </summary>
        [SugarColumn(ColumnName = "linear_max", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal LinearMax { get; set; }
        /// <summary>
        /// 线密度下限
        /// </summary>
        [SugarColumn(ColumnName = "linear_min", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal LinearMin { get; set; }
        /// <summary>
        /// 线密度目标值
        /// </summary>
        [SugarColumn(ColumnName = "linear_tar", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal LinearTar { get; set; }
        /// <summary>
        /// 单丝倍数
        /// </summary>
        [SugarColumn(ColumnName = "mono", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal Mono { get; set; }
        /// <summary>
        /// 工字轮型号
        /// </summary>
        [SugarColumn(ColumnName = "spool_type", ColumnDataType = "nvarchar", Length = 50,IsNullable = true)]
        public string SpoolType { get; set; }
        /// <summary>
        /// 工字轮料号
        /// </summary>
        [SugarColumn(ColumnName = "spool_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string SpoolCode { get; set; }
        /// <summary>
        /// 单卷长度
        /// </summary>
        [SugarColumn(ColumnName = "length", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal Length { get; set; }
        /// <summary>
        /// 涂油量
        /// </summary>
        [SugarColumn(ColumnName = "oil_qty", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal OilQty { get; set; }
        /// <summary>
        /// 润滑液种类
        /// </summary>
        [SugarColumn(ColumnName = "lub_type", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string LubType { get; set; }
        /// <summary>
        /// 排线间距
        /// </summary>
        [SugarColumn(ColumnName = "line_space", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal LineSpace { get; set; }
        /// <summary>
        /// 捻距
        /// </summary>
        [SugarColumn(ColumnName = "line_length", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal LayLength { get; set; }
        /// <summary>
        /// 捻向
        /// </summary>
        [SugarColumn(ColumnName = "lay_direct", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string LayDirect { get; set; }
        /// <summary>
        /// 客户标准索引号
        /// </summary>
        [SugarColumn(ColumnName = "cum_index", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string CumIndex { get; set; }
        /// <summary>
        /// 有无焊点
        /// </summary>
        [SugarColumn(ColumnName = "is_solder", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string IsSolder { get; set; }
        /// <summary>
        /// SKU号
        /// </summary>
        [SugarColumn(ColumnName = "sku_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string SKUCode { get; set; }
        /// <summary>
        /// SKU描述
        /// </summary>
        [SugarColumn(ColumnName = "sku_desc", ColumnDataType = "nvarchar", Length = 200, IsNullable = true)]
        public string SKUDesc { get; set; }
        /// <summary>
        /// 控制扭转
        /// </summary>
        [SugarColumn(ColumnName = "tors", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string Tors { get; set; }
        /// <summary>
        /// 包装组ID
        /// </summary>
        [SugarColumn(ColumnName = "pack_group_id", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string PackGroupId { get; set; }
        /// <summary>
        /// 黑盘取样
        /// </summary>
        [SugarColumn(ColumnName = "black_samp", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string BlackSamp { get; set; }
        /// <summary>
        /// 黑盘检验
        /// </summary>
        [SugarColumn(ColumnName = "black_chk", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string BlackChk { get; set; }
        /// <summary>
        /// 客户编码
        /// </summary>
        [SugarColumn(ColumnName = "cust_code", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string CustCode { get; set; }
        /// <summary>
        /// 客户描述
        /// </summary>
        [SugarColumn(ColumnName = "cust_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string CustName { get; set; }
        /// <summary>
        /// 收货地址编码
        /// </summary>
        [SugarColumn(ColumnName = "address_code", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string AddressCode { get; set; }
        /// <summary>
        /// 收货地址名称
        /// </summary>
        [SugarColumn(ColumnName = "address_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string AddressName { get; set; }
        /// <summary>
        /// 生产批次数量（箱/批）
        /// </summary>
        [SugarColumn(ColumnName = "qty", Length = 18, DecimalDigits = 2, IsNullable = true)]
        public decimal Qty { get; set; }
        /// <summary>
        /// 每箱最大焊点盘数（个）
        /// </summary>
        [SugarColumn(ColumnName = "box_max_solder", Length = 18, DecimalDigits = 2, IsNullable = true)]
        public decimal BoxMaxSolder { get; set; }
        /// <summary>
        /// 工字轮最大焊点数（个）
        /// </summary>
        [SugarColumn(ColumnName = "spool_max_solder", Length = 18, DecimalDigits = 2, IsNullable = true)]
        public decimal SpoolMaxSolder { get; set; }
        /// <summary>
        /// OVC比例
        /// </summary>
        [SugarColumn(ColumnName = "ovc", Length = 18, DecimalDigits = 2, IsNullable = true)]
        public decimal OVC { get; set; }
        /// <summary>
        /// 起鼓等级
        /// </summary>
        [SugarColumn(ColumnName = "drumm_level", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string DrummLevel { get; set; }
        /// <summary>
        /// 公司代码
        /// </summary>
        [SugarColumn(ColumnName = "com_code", ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ComCode { get; set; }
        /// <summary>
        /// 公司名称
        /// </summary>
        [SugarColumn(ColumnName = "com_name", ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string ComName { get; set; }
        /// <summary>
        /// 计量单位
        /// </summary>
        [SugarColumn(ColumnName = "calc_unit", ColumnDataType = "nvarchar", Length = 10, IsNullable = true)]
        public string CalcUnit { get; set; }
        /// <summary>
        /// 库存单位
        /// </summary>
        [SugarColumn(ColumnName = "stock_unit", ColumnDataType = "nvarchar", Length = 10, IsNullable = true)]
        public string StockUnit { get; set; }
        /// <summary>
        /// 单重
        /// </summary>
        [SugarColumn(ColumnName = "weight", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal Weight { get; set; }
        /// <summary>
        /// 单重单位
        /// </summary>
        [SugarColumn(ColumnName = "weight_unit", ColumnDataType = "nvarchar", Length = 10, IsNullable = true)]
        public string WeightUnit { get; set; }
        /// <summary>
        /// 是否启用时效
        /// </summary>
        [SugarColumn(ColumnName = "is_hold")]
        public bool IsHold { get; set; }
        /// <summary>
        /// 时效时长
        /// </summary>
        [SugarColumn(ColumnName = "hold_duration", Length = 18, DecimalDigits = 2)]
        public decimal HoldDuration { get; set; }
    }
}
