﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  容器表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Base_ContInfo")]
    public partial class BaseContinfo : BaseModel
    {
        /// <summary>
        /// 仓库ID
        /// </summary>
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "仓库ID")]
        public long WarehouseId { get; set; }

        /// <summary>
        ///  是否停用 0正常 1停用
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsStop { get; set; }

        /// <summary>
        /// 容器条码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = false)]
        public string ContBarCode { get; set; }

        /// <summary>
        ///  容器名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = false)]
        public string Name { get; set; }

        /// <summary>
        ///  容器类型
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string TypeCode { get; set; }

        /// <summary>
        ///  容器数量，如托盘组
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int PrintQty { get; set; }

        /// <summary>
        ///  长度
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal LengthQty { get; set; }

        /// <summary>
        ///  宽度
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal WidthQty { get; set; }

        /// <summary>
        ///  高度
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal HighQty { get; set; }

        /// <summary>
        ///  重量
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal WeightQty { get; set; }
    }
}
