﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    /// 投料信息表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_BomInfo")]
    public partial class BillBominfo : BaseModel
    {
        /// <summary>
        /// 是否停用
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int IsStop { get; set; }

        /// <summary>
        /// 大类编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = false)]
        public string ProCode { get; set; }

        /// <summary>
        /// 编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string Code { get; set; }

        /// <summary>
        /// 名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 500, IsNullable = false)]
        public string Name { get; set; }

        /// <summary>
        /// 湿拉物料id
        /// </summary>
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false)]
        public long MatId { get; set; }

        /// <summary>
        /// 湿拉物料编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string MatCode { get; set; }

        /// <summary>
        /// 工字轮配比
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal HWCountQty { get; set; }

        /// <summary>
        /// 帘线物料编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ProMatCode { get; set; }

        /// <summary>
        /// 是否停用
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int IsDelete { get; set; }
    }
}
