﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  垛形主表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_BomSetGrp", tableDescription: "垛形主表")]
    public partial class BillBomsetgrp : BaseModel
    {
        /// <summary>
        /// 是否停用
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否停用")]
        public int IsStop { get; set; }

        /// <summary>
        /// 垛型编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "垛型编码")]
        public string Code { get; set; }

        /// <summary>
        ///  短垛型编码
        /// </summary>
        [SugarColumn(ColumnDataType = "smallint", IsNullable = false, ColumnDescription = "短垛型编码")]
        public short ShortCode { get; set; }

        /// <summary>
        /// 垛型名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = false, ColumnDescription = "垛型名称")]
        public string Name { get; set; }

        /// <summary>
        /// BomCode（投料信息）
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = false, ColumnDescription = "BomCode（投料信息）")]
        public string BomCode { get; set; }

        /// <summary>
        /// 帘线物料编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "帘线物料编码")]
        public string ProMaterCode { get; set; }

        /// <summary>
        /// 工字轮个数
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "工字轮个数")]
        public int HWCountQty { get; set; }

        /// <summary>
        /// 托盘类型
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "托盘类型")]
        public string TpTypeCode { get; set; }

        /// <summary>
        /// 层数
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "层数")]
        public int LayerCountQty { get; set; }
        /// <summary>
        /// 垛型大类
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "垛型大类")]
        public int StampType { get; set; }
        
    }


}
