﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    /// 垛型明细表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_BomSetInfo", tableDescription: "垛型明细表")]
    public partial class BillBomsetinfo : BaseModel
    {
        /// <summary>
        /// 垛型id
        /// </summary>
        [SugarColumn(ColumnDataType = "bigint", IsNullable = false, ColumnDescription = "垛型id")]
        public long BomSetHdrId { get; set; }

        /// <summary>
        /// 是否停用
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否停用")]
        public int IsStop { get; set; }

        /// <summary>
        /// 是否空置
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否空置")]
        public int IsEmpty { get; set; }

        /// <summary>
        /// 坐标号
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false, ColumnDescription = "坐标号")]
        public string XYNo { get; set; }

        /// <summary>
        /// 物料id
        /// </summary>
        [SugarColumn(ColumnDataType = "bigint", ColumnDescription = "物料id")]
        public long MatId { get; set; }

        /// <summary>
        /// 物料编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", IsNullable = true, Length = 50, ColumnDescription = "物料编码")]
        public string MatCode { get; set; }

        /// <summary>
        /// 正反面
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "正反面")]
        public int SideNum { get; set; }

        /// <summary>
        /// 工字轮类型
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "工字轮类型")]
        public string SpoolType { get; set; }

        /// <summary>
        /// 钢丝类型
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true, ColumnDescription = "钢丝类型")]
        public string SilkType { get; set; }

        /// <summary>
        /// 钢丝直径
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = true, ColumnDescription = "钢丝直径")]
        public decimal SilkDiam { get; set; }

        /// <summary>
        /// 钢丝直径上限
        /// </summary>
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = true, ColumnDescription = "钢丝直径上限")]
        public decimal SilkDiamMaxCount { get; set; }

        /// <summary>
        /// 数量上限
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "数量上限")]
        public int QtyMaxCount { get; set; }

        /// <summary>
        /// 是否芯股
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否芯股")]
        public int IsCore { get; set; }

        /// <summary>
        /// 09垛型里面的行（1-12）
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true, ColumnDescription = "09垛型里面的行（1-12）")]
        public int Row { get; set; }

        /// <summary>
        /// 是否混合料行（09垛型使用，1是0否）
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "是否混合料行（09垛型使用，1是0否）")]
        public int IsMixRow { get; set; }

        /// <summary>
        /// 混合料行编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", IsNullable = true, Length = 50, ColumnDescription = "混合料行编码")]
        public string MixRowCode { get; set; }

        /// <summary>
        ///  第一种第二种第三种
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "第一种第二种第三种")]
        public int CategoryId { get; set; }
    }
}
