﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  排库表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_PaiKu")]
    public partial class BillPaiKu : BaseModel
    {
        /// <summary>
        ///  垛型
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(BomsetgrpId))]
        public BillBomsetgrp? Bomsetgrp { get; set; }

        /// <summary>
        ///  垛型ID
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "垛型ID")]
        public long BomsetgrpId { get; set; }

        /// <summary>
        /// 垛型名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = true)]
        public string BomsetgrpName { get; set; }

        /// <summary>
        ///  仓库
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(WarehousId))]
        public BaseWarehouse? Warehouse { get; set; }

        /// <summary>
        ///  所属仓库Id
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "垛型ID")]
        public long WarehousId { get; set; }

        /// <summary>
        ///  所属仓库编码（1N,1S,2N,2S,3N,3S）
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50)]
        public string WarehouseCode { get; set; }

        /// <summary>
        ///  垛型对应此仓库的占比
        /// </summary>
        public float Percent { get; set; }
    }
}