﻿using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  环形库码垛缓存信息
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_RingPalletizingInfo")]
    public class BillRingPalletizingInfo : BaseModel
    {
        /// <summary>
        ///  仓库ID
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "仓库ID")]
        public long WareHouseId { get; set; }

        /// <summary>
        ///  任务
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(WareHouseId))]
        public BaseWarehouse WareHouse { get; set; }

        /// <summary>
        ///  垛形主表ID
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "垛形主表ID")]
        public long BomSetGrpId { get; set; }

        /// <summary>
        ///  垛形主表
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(BomSetGrpId))]
        public BillBomsetgrp BomsetGrp { get; set; }

        /// <summary>
        /// 工字轮个数
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "工字轮个数")]
        public int HWCountQty { get; set; }

        /// <summary>
        /// BomCode（投料信息）/物料号
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 200, IsNullable = false, ColumnDescription = "BomCode（投料信息）")]
        public string BomCode { get; set; }

        /// <summary>
        /// 已有工字轮个数
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = false, ColumnDescription = "已有工字轮个数")]
        public int HaveQty { get; set; }

        /// <summary>
        /// 是否出库
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "是否出库")]
        public bool Out { get; set; }

        /// <summary>
        ///  上一次分配时的放置位信息
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int LastXYNO { get; set; }

        ///// <summary>
        ///// 码垛工位
        ///// </summary>
        //[SugarColumn(ColumnDataType = "nvarchar", Length = 20, IsNullable = true, ColumnDescription = "码垛工位（在直接码垛的环形库拥有此功能）")]
        //public string? MaDuoGongWei { get; set; }
    }
}