﻿using SqlSugar;
using System;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  码垛工字轮信息
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_SpoolTrans")]
    public class BillSpoolTrans : BaseModel
    {
        /// <summary>
        /// 工字轮条码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50)]
        public string ConBarCode { get; set; }

        /// <summary>
        /// 分拣库仓库编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string WarehouseCode { get; set; }

        /// <summary>
        /// 分拣库序号
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int WarehouseSort { get; set; }

        /// <summary>
        /// 南北向
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string Direct { get; set; }

        /// <summary>
        /// 输送线号
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int ConveyorSort { get; set; }

        /// <summary>
        /// 位置序号
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int LocSort { get; set; }

        /// <summary>
        /// 湿拉物料编码
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string MatCode { get; set; }

        /// <summary>
        /// 异常盘类型
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int ErrType { get; set; }

        /// <summary>
        /// 异常盘信息
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ErrMsg { get; set; }

        /// <summary>
        /// 湿拉工序订单号
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string BillCode { get; set; }

        /// <summary>
        ///  生产订单号
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string WorkOrder { get; set; }
    }

    /// <summary>
    ///  异常信息
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Base_ErrorInfo")]
    public class BaseErrorInfo
    {
        /// <summary>
        /// ID
        /// </summary>
        [SugarColumn(IsPrimaryKey = true, IsIdentity = true, ColumnDescription = "ID")]
        public int ID { get; set; }

        /// <summary>
        /// 业务名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string BusName { get; set; }

        /// <summary>
        /// 业务名称
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string BarCode { get; set; }

        /// <summary>
        ///  异常描述信息
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 250, IsNullable = true)]
        public string Message { get; set; }

        /// <summary>
        /// 次数
        /// </summary>
        [SugarColumn(ColumnDataType = "int", IsNullable = true)]
        public int Count { get; set; }

        /// <summary>
        ///  memo
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 250, IsNullable = true)]
        public string Memo { get; set; }

        /// <summary>
        /// AddTime
        /// </summary>
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false)]
        public DateTime AddTime { get; set; } = DateTime.Now;
    }
}