﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Text;

namespace wms.sqlsugar.model.fj
{
    /// <summary>
    ///  排库表
    /// </summary>
    [Tenant("fj")]
    [SugarTable("Bill_WarehouseScheduling")]
    public class BillWarehouseScheduling: BaseModel
    {
        /// <summary>
        ///  垛型主信息Id
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "垛型ID")]
        public long BomSetGrpId { get; set; }

        /// <summary>
        ///  垛型名称
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "垛型名称")]
        public string? BomSetGrpName { get; set; }

        /// <summary>
        ///  垛型主信息
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(BomSetGrpId))]
        public BillBomsetgrp? BomSetGrp { get; set; }

        /// <summary>
        ///  仓库ID
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDescription = "仓库ID")]
        public long? WarehouseId { get; set; }

        /// <summary>
        ///  仓库名称
        /// </summary>
        [SugarColumn(IsNullable = true, ColumnDescription = "仓库名称")]
        public string? WarehouseName { get; set; }

        /// <summary>
        ///  仓库
        /// </summary>
        [Navigate(NavigateType.OneToOne,nameof(WarehouseId))]
        public BaseWarehouse? Warehouse { get; set; }

        /// <summary>
        ///  分配比例 最大值为10
        /// </summary>
        [SugarColumn(IsNullable = false, ColumnDescription = "分配比例")]
        public int AllocationRatio { get; set; }
    }
}
